diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/on-off-helper.h ns-3.44/src/applications/helper/on-off-helper.h
--- ns-3.43/src/applications/helper/on-off-helper.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/on-off-helper.h	2025-03-09 16:55:49.347370900 -0700
@@ -9,8 +9,8 @@
 #ifndef ON_OFF_HELPER_H
 #define ON_OFF_HELPER_H
 
-#include <ns3/application-helper.h>
-#include <ns3/data-rate.h>
+#include "ns3/application-helper.h"
+#include "ns3/data-rate.h"
 
 #include <stdint.h>
 
@@ -18,8 +18,8 @@
 {
 
 /**
- * \ingroup onoff
- * \brief A helper to make it easier to instantiate an ns3::OnOffApplication
+ * @ingroup onoff
+ * @brief A helper to make it easier to instantiate an ns3::OnOffApplication
  * on a set of nodes.
  */
 class OnOffHelper : public ApplicationHelper
@@ -28,11 +28,11 @@
     /**
      * Create an OnOffHelper to make it easier to work with OnOffApplications
      *
-     * \param protocol the name of the protocol to use to send traffic
+     * @param protocol the name of the protocol to use to send traffic
      *        by the applications. This string identifies the socket
      *        factory type used to create sockets for the applications.
      *        A typical value would be ns3::UdpSocketFactory.
-     * \param address the address of the remote node to send traffic
+     * @param address the address of the remote node to send traffic
      *        to.
      */
     OnOffHelper(const std::string& protocol, const Address& address);
@@ -42,8 +42,8 @@
      * setting the attributes OnTime to constant 1000 seconds, OffTime to
      * constant 0 seconds, and the DataRate and PacketSize set accordingly
      *
-     * \param dataRate DataRate object for the sending rate
-     * \param packetSize size in bytes of the packet payloads generated
+     * @param dataRate DataRate object for the sending rate
+     * @param packetSize size in bytes of the packet payloads generated
      */
     void SetConstantRate(DataRate dataRate, uint32_t packetSize = 512);
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/packet-sink-helper.cc ns-3.44/src/applications/helper/packet-sink-helper.cc
--- ns-3.43/src/applications/helper/packet-sink-helper.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/packet-sink-helper.cc	2025-03-09 16:55:49.347370900 -0700
@@ -8,7 +8,7 @@
 
 #include "packet-sink-helper.h"
 
-#include <ns3/string.h>
+#include "ns3/string.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/packet-sink-helper.h ns-3.44/src/applications/helper/packet-sink-helper.h
--- ns-3.43/src/applications/helper/packet-sink-helper.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/packet-sink-helper.h	2025-03-09 16:55:49.347370900 -0700
@@ -9,14 +9,14 @@
 #ifndef PACKET_SINK_HELPER_H
 #define PACKET_SINK_HELPER_H
 
-#include <ns3/application-helper.h>
+#include "ns3/application-helper.h"
 
 namespace ns3
 {
 
 /**
- * \ingroup packetsink
- * \brief A helper to make it easier to instantiate an ns3::PacketSinkApplication
+ * @ingroup packetsink
+ * @brief A helper to make it easier to instantiate an ns3::PacketSinkApplication
  * on a set of nodes.
  */
 class PacketSinkHelper : public ApplicationHelper
@@ -25,11 +25,11 @@
     /**
      * Create a PacketSinkHelper to make it easier to work with PacketSinkApplications
      *
-     * \param protocol the name of the protocol to use to receive traffic
+     * @param protocol the name of the protocol to use to receive traffic
      *        This string identifies the socket factory type used to create
      *        sockets for the applications.  A typical value would be
      *        ns3::TcpSocketFactory.
-     * \param address the address of the sink,
+     * @param address the address of the sink,
      *
      */
     PacketSinkHelper(const std::string& protocol, const Address& address);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/three-gpp-http-helper.cc ns-3.44/src/applications/helper/three-gpp-http-helper.cc
--- ns-3.43/src/applications/helper/three-gpp-http-helper.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/three-gpp-http-helper.cc	2025-03-09 16:55:49.347370900 -0700
@@ -22,7 +22,7 @@
 ThreeGppHttpClientHelper::ThreeGppHttpClientHelper(const Address& address)
     : ApplicationHelper("ns3::ThreeGppHttpClient")
 {
-    m_factory.Set("RemoteServerAddress", AddressValue(address));
+    m_factory.Set("Remote", AddressValue(address));
 }
 
 // HTTP SERVER HELPER /////////////////////////////////////////////////////////
@@ -30,7 +30,7 @@
 ThreeGppHttpServerHelper::ThreeGppHttpServerHelper(const Address& address)
     : ApplicationHelper("ns3::ThreeGppHttpServer")
 {
-    m_factory.Set("LocalAddress", AddressValue(address));
+    m_factory.Set("Local", AddressValue(address));
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/three-gpp-http-helper.h ns-3.44/src/applications/helper/three-gpp-http-helper.h
--- ns-3.43/src/applications/helper/three-gpp-http-helper.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/three-gpp-http-helper.h	2025-03-09 16:55:49.347370900 -0700
@@ -15,13 +15,13 @@
 #ifndef THREE_GPP_HTTP_HELPER_H
 #define THREE_GPP_HTTP_HELPER_H
 
-#include <ns3/application-helper.h>
+#include "ns3/application-helper.h"
 
 namespace ns3
 {
 
 /**
- * \ingroup applications
+ * @ingroup applications
  * Helper to make it easier to instantiate an ThreeGppHttpClient on a set of nodes.
  */
 class ThreeGppHttpClientHelper : public ApplicationHelper
@@ -30,13 +30,13 @@
     /**
      * Create a ThreeGppHttpClientHelper to make it easier to work with ThreeGppHttpClient
      * applications.
-     * \param address The address of the remote server node to send traffic to.
+     * @param address The address of the remote server node to send traffic to.
      */
     ThreeGppHttpClientHelper(const Address& address);
 }; // end of `class ThreeGppHttpClientHelper`
 
 /**
- * \ingroup http
+ * @ingroup http
  * Helper to make it easier to instantiate an ThreeGppHttpServer on a set of nodes.
  */
 class ThreeGppHttpServerHelper : public ApplicationHelper
@@ -45,7 +45,7 @@
     /**
      * Create a ThreeGppHttpServerHelper to make it easier to work with
      * ThreeGppHttpServer applications.
-     * \param address The address of the server.
+     * @param address The address of the server.
      */
     ThreeGppHttpServerHelper(const Address& address);
 }; // end of `class ThreeGppHttpServerHelper`
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/udp-client-server-helper.cc ns-3.44/src/applications/helper/udp-client-server-helper.cc
--- ns-3.43/src/applications/helper/udp-client-server-helper.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/udp-client-server-helper.cc	2025-03-09 16:55:49.347370900 -0700
@@ -8,8 +8,9 @@
 
 #include "udp-client-server-helper.h"
 
-#include <ns3/string.h>
-#include <ns3/uinteger.h>
+#include "ns3/address-utils.h"
+#include "ns3/string.h"
+#include "ns3/uinteger.h"
 
 namespace ns3
 {
@@ -25,6 +26,12 @@
     SetAttribute("Port", UintegerValue(port));
 }
 
+UdpServerHelper::UdpServerHelper(const Address& address)
+    : UdpServerHelper()
+{
+    SetAttribute("Local", AddressValue(address));
+}
+
 UdpClientHelper::UdpClientHelper()
     : ApplicationHelper(UdpClient::GetTypeId())
 {
@@ -33,13 +40,12 @@
 UdpClientHelper::UdpClientHelper(const Address& address)
     : UdpClientHelper()
 {
-    SetAttribute("RemoteAddress", AddressValue(address));
+    SetAttribute("Remote", AddressValue(address));
 }
 
 UdpClientHelper::UdpClientHelper(const Address& address, uint16_t port)
-    : UdpClientHelper(address)
+    : UdpClientHelper(addressUtils::ConvertToSocketAddress(address, port))
 {
-    SetAttribute("RemotePort", UintegerValue(port));
 }
 
 UdpTraceClientHelper::UdpTraceClientHelper()
@@ -50,16 +56,15 @@
 UdpTraceClientHelper::UdpTraceClientHelper(const Address& address, const std::string& filename)
     : UdpTraceClientHelper()
 {
-    SetAttribute("RemoteAddress", AddressValue(address));
+    SetAttribute("Remote", AddressValue(address));
     SetAttribute("TraceFilename", StringValue(filename));
 }
 
 UdpTraceClientHelper::UdpTraceClientHelper(const Address& address,
                                            uint16_t port,
                                            const std::string& filename)
-    : UdpTraceClientHelper(address, filename)
+    : UdpTraceClientHelper(addressUtils::ConvertToSocketAddress(address, port), filename)
 {
-    SetAttribute("RemotePort", UintegerValue(port));
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/udp-client-server-helper.h ns-3.44/src/applications/helper/udp-client-server-helper.h
--- ns-3.43/src/applications/helper/udp-client-server-helper.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/udp-client-server-helper.h	2025-03-09 16:55:49.347370900 -0700
@@ -9,18 +9,18 @@
 #ifndef UDP_CLIENT_SERVER_HELPER_H
 #define UDP_CLIENT_SERVER_HELPER_H
 
-#include <ns3/application-helper.h>
-#include <ns3/udp-client.h>
-#include <ns3/udp-server.h>
-#include <ns3/udp-trace-client.h>
+#include "ns3/application-helper.h"
+#include "ns3/udp-client.h"
+#include "ns3/udp-server.h"
+#include "ns3/udp-trace-client.h"
 
 #include <stdint.h>
 
 namespace ns3
 {
 /**
- * \ingroup udpclientserver
- * \brief Create a server application which waits for input UDP packets
+ * @ingroup udpclientserver
+ * @brief Create a server application which waits for input UDP packets
  *        and uses the information carried into their payload to compute
  *        delay and to determine if some packets are lost.
  */
@@ -38,14 +38,22 @@
      * Create UdpServerHelper which will make life easier for people trying
      * to set up simulations with udp-client-server application.
      *
-     * \param port The port the server will wait on for incoming packets
+     * @param port The port the server will wait on for incoming packets
      */
     UdpServerHelper(uint16_t port);
+
+    /**
+     * Create UdpServerHelper which will make life easier for people trying
+     * to set up simulations with udp-client-server application.
+     *
+     * @param address The address the server will bind to
+     */
+    UdpServerHelper(const Address& address);
 };
 
 /**
- * \ingroup udpclientserver
- * \brief Create a client application which sends UDP packets carrying
+ * @ingroup udpclientserver
+ * @brief Create a client application which sends UDP packets carrying
  *  a 32bit sequence number and a 64 bit time stamp.
  *
  */
@@ -65,8 +73,8 @@
      * addresses that do not include a port value (e.g., Ipv4Address and
      * Ipv6Address).
      *
-     * \param ip The IP address of the remote UDP server
-     * \param port The port number of the remote UDP server
+     * @param ip The IP address of the remote UDP server
+     * @param port The port number of the remote UDP server
      */
 
     UdpClientHelper(const Address& ip, uint16_t port);
@@ -76,14 +84,14 @@
      * addresses that do include a port value (e.g., InetSocketAddress and
      * Inet6SocketAddress).
      *
-     * \param addr The address of the remote UDP server
+     * @param addr The address of the remote UDP server
      */
 
     UdpClientHelper(const Address& addr);
 };
 
 /**
- * \ingroup udpclientserver
+ * @ingroup udpclientserver
  * Create UdpTraceClient application which sends UDP packets based on a trace
  * file of an MPEG4 stream. Trace files could be downloaded form :
  * https://web.archive.org/web/20190907061916/http://www2.tkn.tu-berlin.de/research/trace/ltvt.html
@@ -110,9 +118,9 @@
      * addresses that do not include a port value (e.g., Ipv4Address and
      * Ipv6Address).
      *
-     * \param ip The IP address of the remote UDP server
-     * \param port The port number of the remote UDP server
-     * \param filename the file from which packet traces will be loaded
+     * @param ip The IP address of the remote UDP server
+     * @param port The port number of the remote UDP server
+     * @param filename the file from which packet traces will be loaded
      */
     UdpTraceClientHelper(const Address& ip, uint16_t port, const std::string& filename = "");
 
@@ -122,8 +130,8 @@
      * addresses that do include a port value (e.g., InetSocketAddress and
      * Inet6SocketAddress).
      *
-     * \param addr The address of the remote UDP server
-     * \param filename the file from which packet traces will be loaded
+     * @param addr The address of the remote UDP server
+     * @param filename the file from which packet traces will be loaded
      */
     UdpTraceClientHelper(const Address& addr, const std::string& filename = "");
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/udp-echo-helper.cc ns-3.44/src/applications/helper/udp-echo-helper.cc
--- ns-3.43/src/applications/helper/udp-echo-helper.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/udp-echo-helper.cc	2025-03-09 16:55:49.347370900 -0700
@@ -8,6 +8,7 @@
 
 #include "udp-echo-helper.h"
 
+#include "ns3/address-utils.h"
 #include "ns3/udp-echo-client.h"
 #include "ns3/udp-echo-server.h"
 #include "ns3/uinteger.h"
@@ -21,17 +22,21 @@
     SetAttribute("Port", UintegerValue(port));
 }
 
+UdpEchoServerHelper::UdpEchoServerHelper(const Address& address)
+    : ApplicationHelper(UdpEchoServer::GetTypeId())
+{
+    SetAttribute("Local", AddressValue(address));
+}
+
 UdpEchoClientHelper::UdpEchoClientHelper(const Address& address, uint16_t port)
-    : ApplicationHelper(UdpEchoClient::GetTypeId())
+    : UdpEchoClientHelper(addressUtils::ConvertToSocketAddress(address, port))
 {
-    SetAttribute("RemoteAddress", AddressValue(address));
-    SetAttribute("RemotePort", UintegerValue(port));
 }
 
 UdpEchoClientHelper::UdpEchoClientHelper(const Address& address)
     : ApplicationHelper(UdpEchoClient::GetTypeId())
 {
-    SetAttribute("RemoteAddress", AddressValue(address));
+    SetAttribute("Remote", AddressValue(address));
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/helper/udp-echo-helper.h ns-3.44/src/applications/helper/udp-echo-helper.h
--- ns-3.43/src/applications/helper/udp-echo-helper.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/helper/udp-echo-helper.h	2025-03-09 16:55:49.347370900 -0700
@@ -9,7 +9,7 @@
 #ifndef UDP_ECHO_HELPER_H
 #define UDP_ECHO_HELPER_H
 
-#include <ns3/application-helper.h>
+#include "ns3/application-helper.h"
 
 #include <stdint.h>
 
@@ -17,8 +17,8 @@
 {
 
 /**
- * \ingroup udpecho
- * \brief Create a server application which waits for input UDP packets
+ * @ingroup udpecho
+ * @brief Create a server application which waits for input UDP packets
  *        and sends them back to the original sender.
  */
 class UdpEchoServerHelper : public ApplicationHelper
@@ -28,14 +28,22 @@
      * Create UdpEchoServerHelper which will make life easier for people trying
      * to set up simulations with echos.
      *
-     * \param port The port the server will wait on for incoming packets
+     * @param port The port the server will wait on for incoming packets
      */
     UdpEchoServerHelper(uint16_t port);
+
+    /**
+     * Create UdpEchoServerHelper which will make life easier for people trying
+     * to set up simulations with echos.
+     *
+     * @param address The address the server will bind to
+     */
+    UdpEchoServerHelper(const Address& address);
 };
 
 /**
- * \ingroup udpecho
- * \brief Create an application which sends a UDP packet and waits for an echo of this packet
+ * @ingroup udpecho
+ * @brief Create an application which sends a UDP packet and waits for an echo of this packet
  */
 class UdpEchoClientHelper : public ApplicationHelper
 {
@@ -45,16 +53,17 @@
      * to set up simulations with echos. Use this variant with addresses that do
      * not include a port value (e.g., Ipv4Address and Ipv6Address).
      *
-     * \param ip The IP address of the remote udp echo server
-     * \param port The port number of the remote udp echo server
+     * @param ip The IP address of the remote udp echo server
+     * @param port The port number of the remote udp echo server
      */
     UdpEchoClientHelper(const Address& ip, uint16_t port);
+
     /**
      * Create UdpEchoClientHelper which will make life easier for people trying
      * to set up simulations with echos. Use this variant with addresses that do
      * include a port value (e.g., InetSocketAddress and Inet6SocketAddress).
      *
-     * \param addr The address of the remote udp echo server
+     * @param addr The address of the remote udp echo server
      */
     UdpEchoClientHelper(const Address& addr);
 
@@ -63,12 +72,12 @@
      * packet (what is sent as data to the server) to the contents of the fill
      * string (including the trailing zero terminator).
      *
-     * \warning The size of resulting echo packets will be automatically adjusted
+     * @warning The size of resulting echo packets will be automatically adjusted
      * to reflect the size of the fill string -- this means that the PacketSize
      * attribute may be changed as a result of this call.
      *
-     * \param app Smart pointer to the application (real type must be UdpEchoClient).
-     * \param fill The string to use as the actual echo data bytes.
+     * @param app Smart pointer to the application (real type must be UdpEchoClient).
+     * @param fill The string to use as the actual echo data bytes.
      */
     void SetFill(Ptr<Application> app, const std::string& fill);
 
@@ -79,13 +88,13 @@
      *
      * The fill byte will be used to initialize the contents of the data packet.
      *
-     * \warning The size of resulting echo packets will be automatically adjusted
+     * @warning The size of resulting echo packets will be automatically adjusted
      * to reflect the dataLength parameter -- this means that the PacketSize
      * attribute may be changed as a result of this call.
      *
-     * \param app Smart pointer to the application (real type must be UdpEchoClient).
-     * \param fill The byte to be repeated in constructing the packet data..
-     * \param dataLength The desired length of the resulting echo packet data.
+     * @param app Smart pointer to the application (real type must be UdpEchoClient).
+     * @param fill The byte to be repeated in constructing the packet data..
+     * @param dataLength The desired length of the resulting echo packet data.
      */
     void SetFill(Ptr<Application> app, uint8_t fill, uint32_t dataLength);
 
@@ -98,14 +107,14 @@
      * by providing a complete buffer with fillLength set to your desired
      * dataLength
      *
-     * \warning The size of resulting echo packets will be automatically adjusted
+     * @warning The size of resulting echo packets will be automatically adjusted
      * to reflect the dataLength parameter -- this means that the PacketSize
      * attribute of the Application may be changed as a result of this call.
      *
-     * \param app Smart pointer to the application (real type must be UdpEchoClient).
-     * \param fill The fill pattern to use when constructing packets.
-     * \param fillLength The number of bytes in the provided fill pattern.
-     * \param dataLength The desired length of the final echo data.
+     * @param app Smart pointer to the application (real type must be UdpEchoClient).
+     * @param fill The fill pattern to use when constructing packets.
+     * @param fillLength The number of bytes in the provided fill pattern.
+     * @param dataLength The desired length of the final echo data.
      */
     void SetFill(Ptr<Application> app, uint8_t* fill, uint32_t fillLength, uint32_t dataLength);
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/application-packet-probe.h ns-3.44/src/applications/model/application-packet-probe.h
--- ns-3.43/src/applications/model/application-packet-probe.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/application-packet-probe.h	2025-03-09 16:55:49.347370900 -0700
@@ -26,7 +26,7 @@
 {
 
 /**
- * \brief Probe to translate from a TraceSource to two more easily parsed TraceSources.
+ * @brief Probe to translate from a TraceSource to two more easily parsed TraceSources.
  *
  * This class is designed to probe an underlying ns3 TraceSource
  * exporting a packet and a socket address.  This probe exports a
@@ -41,43 +41,43 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     ApplicationPacketProbe();
     ~ApplicationPacketProbe() override;
 
     /**
-     * \brief Set a probe value
+     * @brief Set a probe value
      *
-     * \param packet set the traced packet equal to this
-     * \param address set the socket address for the traced packet equal to this
+     * @param packet set the traced packet equal to this
+     * @param address set the socket address for the traced packet equal to this
      */
     void SetValue(Ptr<const Packet> packet, const Address& address);
 
     /**
-     * \brief Set a probe value by its name in the Config system
+     * @brief Set a probe value by its name in the Config system
      *
-     * \param path config path to access the probe
-     * \param packet set the traced packet equal to this
-     * \param address set the socket address for the traced packet equal to this
+     * @param path config path to access the probe
+     * @param packet set the traced packet equal to this
+     * @param address set the socket address for the traced packet equal to this
      */
     static void SetValueByPath(std::string path, Ptr<const Packet> packet, const Address& address);
 
     /**
-     * \brief connect to a trace source attribute provided by a given object
+     * @brief connect to a trace source attribute provided by a given object
      *
-     * \param traceSource the name of the attribute TraceSource to connect to
-     * \param obj ns3::Object to connect to
-     * \return true if the trace source was successfully connected
+     * @param traceSource the name of the attribute TraceSource to connect to
+     * @param obj ns3::Object to connect to
+     * @return true if the trace source was successfully connected
      */
     bool ConnectByObject(std::string traceSource, Ptr<Object> obj) override;
 
     /**
-     * \brief connect to a trace source provided by a config path
+     * @brief connect to a trace source provided by a config path
      *
-     * \param path Config path to bind to
+     * @param path Config path to bind to
      *
      * Note, if an invalid path is provided, the probe will not be connected
      * to anything.
@@ -86,11 +86,11 @@
 
   private:
     /**
-     * \brief Method to connect to an underlying ns3::TraceSource with
+     * @brief Method to connect to an underlying ns3::TraceSource with
      * arguments of type Ptr<const Packet> and const Address&
      *
-     * \param packet the traced packet
-     * \param address the socket address for the traced packet
+     * @param packet the traced packet
+     * @param address the socket address for the traced packet
      *
      */
     void TraceSink(Ptr<const Packet> packet, const Address& address);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/bulk-send-application.cc ns-3.44/src/applications/model/bulk-send-application.cc
--- ns-3.43/src/applications/model/bulk-send-application.cc	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/bulk-send-application.cc	2025-03-09 16:55:49.347370900 -0700
@@ -8,7 +8,6 @@
 
 #include "bulk-send-application.h"
 
-#include "ns3/address.h"
 #include "ns3/boolean.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
@@ -34,7 +33,7 @@
 {
     static TypeId tid =
         TypeId("ns3::BulkSendApplication")
-            .SetParent<Application>()
+            .SetParent<SourceApplication>()
             .SetGroupName("Applications")
             .AddConstructor<BulkSendApplication>()
             .AddAttribute("SendSize",
@@ -42,23 +41,6 @@
                           UintegerValue(512),
                           MakeUintegerAccessor(&BulkSendApplication::m_sendSize),
                           MakeUintegerChecker<uint32_t>(1))
-            .AddAttribute("Remote",
-                          "The address of the destination",
-                          AddressValue(),
-                          MakeAddressAccessor(&BulkSendApplication::m_peer),
-                          MakeAddressChecker())
-            .AddAttribute("Local",
-                          "The Address on which to bind the socket. If not set, it is generated "
-                          "automatically.",
-                          AddressValue(),
-                          MakeAddressAccessor(&BulkSendApplication::m_local),
-                          MakeAddressChecker())
-            .AddAttribute("Tos",
-                          "The Type of Service used to send IPv4 packets. "
-                          "All 8 bits of the TOS byte are set (including ECN bits).",
-                          UintegerValue(0),
-                          MakeUintegerAccessor(&BulkSendApplication::m_tos),
-                          MakeUintegerChecker<uint8_t>())
             .AddAttribute("MaxBytes",
                           "The total number of bytes to send. "
                           "Once these bytes are sent, "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/applications/model/bulk-send-application.h ns-3.44/src/applications/model/bulk-send-application.h
--- ns-3.43/src/applications/model/bulk-send-application.h	2024-10-09 16:41:09.848655700 -0700
+++ ns-3.44/src/applications/model/bulk-send-application.h	2025-03-09 16:55:49.347370900 -0700
@@ -10,9 +10,8 @@
 #define BULK_SEND_APPLICATION_H
 
 #include "seq-ts-size-header.h"
+#include "source-application.h"
 
-#include "ns3/address.h"
-#include "ns3/application.h"
 #include "ns3/event-id.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
@@ -20,14 +19,13 @@
 namespace ns3
 {
 
-class Address;
 class Socket;
 class TcpHeader;
 class TcpSocketBase;
 
 /**
- * \ingroup applications
- * \defgroup bulksend BulkSendApplication
+ * @ingroup applications
+ * @defgroup bulksend BulkSendApplication
  *
  * This traffic generator simply sends data
  * as fast as possible up to MaxBytes or until
@@ -42,9 +40,9 @@
  */
 
 /**
- * \ingroup bulksend
+ * @ingroup bulksend
  *
- * \brief Send as much traffic as possible, trying to fill the bandwidth.
+ * @brief Send as much traffic as possible, trying to fill the bandwidth.
  *
  * This traffic generator simply sends data
  * as fast as possible up to MaxBytes or until
@@ -64,21 +62,20 @@
  * (enable its "EnableSeqTsSizeHeader" attribute), or users may extract
  * the header via trace sources.
  */
-class BulkSendApplication : public Application
+class BulkSendApplication : public SourceApplication
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     BulkSendApplication();
-
     ~BulkSendApplication() override;
 
     /**
-     * \brief Set the upper bound for the total number of bytes to send.
+     * @brief Set the upper bound for the total number of bytes to send.
      *
      * Once this bound is reached, no more application bytes are sent. If the
      * application is stopped during the simulation and restarted, the
@@ -88,13 +85,13 @@
      * there is no upper bound; i.e. data is sent until the application
      * or simulation is stopped.
      *
-     * \param maxBytes the upper bound of bytes to send
+     * @param maxBytes the upper bound of bytes to send
      */
     void SetMaxBytes(uint64_t maxBytes);
 
     /**
-     * \brief Get the socket this application is attached to.
-     * \return pointer to associated socket
+     * @brief Get the socket this application is attached to.
+     * @return pointer to associated socket
      */
     Ptr<Socket> GetSocket() const;
 
@@ -106,17 +103,14 @@
     void StopApplication() override;
 
     /**
-     * \brief Send data until the L4 transmission buffer is full.
-     * \param from From address
-     * \param to To address
+     * @brief Send data until the L4 transmission buffer is full.
+     * @param from From address
+     * @param to To address
      */
     void SendData(const Address& from, const Address& to);
 
     Ptr<Socket> m_socket;                //!< Associated socket
-    Address m_peer;                      //!< Peer address
-    Address m_local;                     //!< Local address to bind to
     bool m_connected;                    //!< True if connected
-    uint8_t m_tos;                       //!< The packets Type of Service
     uint32_t m_sendSize;                 //!< Size of data to send each time
     uint64_t m_maxBytes;                 //!< Limit total number of bytes sent
     uint64_t m_totBytes;                 //!< Total bytes sent so far
@@ -143,32 +137,32 @@
 
   private:
     /**
-     * \brief Connection Succeeded (called by Socket through a callback)
-     * \param socket the connected socket
+     * @brief Connection Succeeded (called by Socket through a callback)
+     * @param socket the connected socket
      */
     void ConnectionSucceeded(Ptr<Socket> socket);
     /**
-     * \brief Connection Failed (called by Socket through a callback)
-     * \param socket the connected socket
+     * @brief Connection Failed (called by Socket through a callback)
+     * @param socket the connected socket
      */
     void ConnectionFailed(Ptr<Socket> socket);
     /**
-     * \brief Send more data as soon as some has been transmitted.
+     * @brief Send more data as soon as some has been transmitted.
      *
      * Used in socket's SetSendCallback - params are forced by it.
      *
-     * \param socket socket to use
-     * \param unused actually unused
+     * @param socket socket to use
+     * @param unused actually unused
      */
     void DataSend(Ptr<Socket> socket, uint32_t unused);
 
     /**
-     *  \brief Packet retransmitted (called by TcpSocketBase sockets via callback)
-     *  \param p the retransmitted packet
-     *  \param header the TCP header
-     *  \param localAddr the local address
-     *  \param peerAddr the peer address
-     *  \param socket the socket that retransmitted the packet
+     *  @brief Packet retransmitted (called by TcpSocketBase sockets via callback)
+     *  @param p the retransmitted packet
+     *  @param header the TCP header
+     *  @param localAddr the local address
+     *  @param peerAddr the peer address
+     *  @param socket the socket that retransmitted the packet
      */
     void PacketRetransmitted(Ptr<const Packet> p,
                              const TcpHeader& header,
